import subprocess
from exception import *

#############################################################################

class Command(object):
  Name_ = None
  Exe_ = None
  def __init__(self, cleanup=False):
    self.cleanup_ = cleanup
    self.acquired_ = False
    self.debug_ = False

  def __del__(self):
    if self.cleanup_:
      if self.acquired_:
        self.release()

  def cleanup(self, val=None):
    if val != None:
      self.cleanup_ = val
    return self.cleanup_

  def acquired(self):
    self.acquired_ = True

  def released(self):
    self.acquired_ = False

  def debug(self, debug=None):
    if debug:
      self.debug_ = debug
    return self.debug_

  def handleReturn(self, retcode, err):
    if retcode != 0:
      raise CmdFailedException(self.Name_, err[0], retcode)

  def _dprintCmd(self, exe, args):
    if exe == args[0]:
      print "%s " % (args[0]) + " ".join(args[1:])
    else:
      print "%s (%s) " % (args[0], exe) + " ".join(args[1:])

  def _commonCmd(self, checks, args, exe=None):
    if not exe:
      exe = args[0]
    if self.debug_:
      self._dprintCmd(exe, args)
      return False
    for i in checks:
      i()
    return True

  def accquire(self):
    pass

  def _acquire(self, checks, args, exe=None):
    if not self._commonCmd(checks, args, exe):
      return
    proc = subprocess.Popen(args, executable=exe,
        stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    (out, err) = proc.communicate()
    self.handleReturn(proc.returncode, err.splitlines())
    self.acquired()

  def release(self):
    pass

  def _release(self, checks, args, exe=None):
    if not self._commonCmd(checks, args, exe):
      return
    proc = subprocess.Popen(args, executable=exe,
        stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    (out, err) = proc.communicate()
    self.handleReturn(proc.returncode, err.splitlines())
    self.released()
