import os

from command import Command
from exception import *

class Cryptsetup(Command):
  Name_ = 'Cryptsetup'
  Exe_ = 'cryptsetup'
  DmPath_ = '/dev/mapper/'
  def __init__(self, device='', name='', cleanup=False):
    Command.__init__(self, cleanup)
    self.device_ = device
    self.name_ = name
    self.path_ = os.path.join(self.DmPath_, name)

  def __str__(self):
    return "%s: \"%s\" on \"%s\"" % (self.Name_, self.device_, self.path_)

  def _checkName(self):
    if not self.name_:
      raise CmdBadArgException(self.Name_, 'no name given')
    if not os.path.exists(self.path_):
      raise CmdBadArgException(self.Name_, 'name \"%s\" does not exist' % self.path_)

  def _checkDevice(self):
    if not self.device_:
      raise CmdBadArgException(self.Name_, 'no device given')
    if not os.path.exists(self.device_):
      raise CmdBadArgException(self.Name_, 'device \"%s\" does not exist' % self.device_)

