from cryptsetup import *

class CryptsetupPlain(Cryptsetup):
  Name_='Cryptsetup-plain'

  def acquire(self):
    """Create a dm-crypt mapping with luks"""
    self._acquire((self._checkName, self._checkDevice),
        (self.Exe_, 'create', self.name_, self.device_))

  def release(self):
    """Remove the dm-crypt mapping"""
    self._release((self._checkDevice,),
        (self.Exe_, 'remove', self.name_))


if __name__ == '__main__':
  a = CryptsetupPlain('/dev/sda1/', 'crypttest')
  a.debug(True)
  a.acquire()
  a.release()
  print a
