import os
import urllib

from grml.util import QueueListBridge


def ishgrep(dir):
    return os.path.isdir(os.path.join(dir, '.hg'))

def iscleaned(repos):
    if len(os.listdir(repos)) == 1:
        return True
    else:
        return False

# from mercurial.util
def walkrepos(path):
    '''yield every hg repository under path, recursively.'''
    def errhandler(err):
        if err.filename == path:
            raise err

    for root, dirs, files in os.walk(path, onerror=errhandler):
        for d in dirs:
            if d == '.hg':
                yield root
                dirs[:] = []
                break

def walkreposFlat(q, path='.'):
    ql = QueueListBridge(q)
    for i in os.listdir(path):
        if os.path.isdir(i) and ishgrep(i):
            ql.append(i)

def walkreposRecursiv(q, path='.'):
    ql = QueueListBridge(q)
    for i in walkrepos(path):
        ql.append(i)

def walkreposConfigFile(q, path='.hgr'):
    ql = QueueListBridge(q)
    raise NotImplementedError()


def walkreposWeb(q, url):
    ql = QueueListBridge(q)
    data = urllib.urlopen(url + '/?style=raw')
    repen = data.readlines()
    repen = map(lambda x: x.strip('/\n'), repen)
    repen = filter(lambda x: len(x) > 0, repen)
    for i in repen:
        ql.append(i)

