import os
import subprocess
import Queue

from exception import *

##############################################################################

class DirChanger(object):
    '''Guard to change directory and goes back if out of scope (exception)'''
    def __init__(self, dir):
        self.owd_ = os.path.abspath('.')
        os.chdir(dir)

    def __del__(self):
        os.chdir(self.owd_)

##############################################################################

def execCmd(cmd, name):
    '''Default function to execute a Command on the shell'''
    proc = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    (out, err) = proc.communicate()
    if proc.returncode != 0:
        raise CmdFailedException(name, err.splitlines()[0], proc.returncode)

##############################################################################

class QueueListBridge(object):
    '''Bridge to use Queue as list on the producer side'''
    def __init__(self, q):
        self.data_ = q
        if isinstance(q, Queue.Queue):
            self._append = lambda x, y: x.put(y)
        else:
            self._append = lambda x, y: x.append(y)

    def append(self, x):
        self._append(self.data_, x)

